【二分】 GukiZ hates Boxes CodeForces - 551C (学生搬石头)

【二分】 GukiZ hates Boxes CodeForces - 551C (学生搬石头)

Professor GukiZ is concerned about making his way to school, because massive piles of boxes are blocking his way.

In total there are n piles of boxes, arranged in a line, from left to right, i-th pile (1 ≤ i ≤ n) containing ai boxes. Luckily, m students are willing to help GukiZ by removing all the boxes from his way. Students are working simultaneously. At time 0, all students are located left of the first pile. It takes one second for every student to move from this position to the first pile, and after that, every student must start performing sequence of two possible operations, each taking one second to complete. Possible operations are:

  1. If i ≠ n, move from pile i to pile i + 1;
  2. If pile located at the position of student is not empty, remove one box from it.

GukiZ’s students aren’t smart at all, so they need you to tell them how to remove boxes before professor comes (he is very impatient man, and doesn’t want to wait). They ask you to calculate minumum time t in seconds for which they can remove all the boxes from GukiZ’s way. Note that students can be positioned in any manner after t seconds, but all the boxes must be removed.

Input
The first line contains two integers n and m (1 ≤ n, m ≤ 105), the number of piles of boxes and the number of GukiZ’s students.

The second line contains n integers a1, a2, … an (0 ≤ ai ≤ 109) where ai represents the number of boxes on i-th pile. It’s guaranteed that at least one pile of is non-empty.

Output
In a single line, print one number, minimum time needed to remove all the boxes in seconds.

Examples
Input
2 1
1 1
Output
4
Input
3 2
1 0 2
Output
5
Input
4 100
3 4 5 4
Output
5

Note
First sample: Student will first move to the first pile (1 second), then remove box from first pile (1 second), then move to the second pile (1 second) and finally remove the box from second pile (1 second).

Second sample: One of optimal solutions is to send one student to remove a box from the first pile and a box from the third pile, and send another student to remove a box from the third pile. Overall, 5 seconds.

Third sample: With a lot of available students, send three of them to remove boxes from the first pile, four of them to remove boxes from the second pile, five of them to remove boxes from the third pile, and four of them to remove boxes from the fourth pile. Process will be over in 5 seconds, when removing the boxes from the last pile is finished.

题意:
路上有n块石头,坐标为x,有m个学生搬石头,从起始位置每走一步需要花费1秒,搬石头需要花1秒,问最少需要多久可以把石头搬完。

思路:
二分需要花费的时间X,检验条件如下:
让所有人一起向前走,走到一堆石头前,就让人去搬它,在这个过程中累计搬石头的时间s,如果走到某个石头处,搬石头的时间s+走到这里的时间i,大于X了,说明人手不够了,需要更多的人来搬石头。
【那么多了人是怎么节省时间的呢?】其实搬石头的时候,无论几个人搬,都需要花费a[i]的时间,节省的时间其实是大家一起走路的时间,对于走到位置i来说,每多一个人,就多了X-i的时间可以用来搬石头。
人手不够添加1个人手时,s就可以少X- i,(因为多了一个人,可以多出X-i的时间搬石头),那么一直走到最远的一堆石头处,如果花费的人数超过了规定人数,一定不可以。
如果人数 = 0(因为人数<0上面已经处理了,这里只考虑=0),但是S>0,说明还需要人手来搬石头,这样也不可以。其他情况成立。

AC代码:

#include <iostream>
#include <stdio.h>
#define maxn 100005

using namespace std;

int n, m, a[maxn], d;
long long sum;

bool c(long long mid)
{
    long long s = 0;
    int num = m;
    for(int i = 1; i <= d; i++)
    {
        s += a[i];
        while(s + i >= mid)
        {
            s -= (mid - i);
            num--;
            if(num < 0)
                return false;
        }
    }
    if(num == 0 && s > 0)
        return false;
    return true;
}

void sol()
{
    long long l = d - 1, r = sum + d + 1;
    while(r - l > 1)
    {
        long long mid = (r - l) / 2 + l;
        if(c(mid))
            r = mid;
        else
            l = mid;
    }
    printf("%lld\n", r);
}

int main()
{
    scanf("%d%d", &n, &m);
    sum = 0;
    for(int i = 1; i <= n; i++)
    {
        scanf("%d", &a[i]);
        sum += a[i];
        if(a[i] != 0)
            d = i;
    }
    sol();
    return 0;
}

猜你喜欢

转载自blog.csdn.net/floraqiu/article/details/81210459